$PAGEWIDTH=120
;*********************************************************************
;     MIDI 
;    V 1.7                             12-02-2008
;---------------------------------------------------------------------
;1.,  ,   
;     (  )    (  )
;2.    
;    29h -    -  59h -  3 
;3.  -   () 1-16 -   (16-0)
;  (  ( ) -   ,  
;   -  HEX     )
;4. P0.7 -> P3.7 -    HEX  
;5. P0.7 -> P3.6 -    (.3)
;6. P0.5 -> P3.6 -    (   VD P3.4)
;          
;7. P0.5 -> P1.1 -    (   VD P3.3)
;         
;8. P0.5 -> P1.2 -   ( )
;          
;9. P0.5 -> P3.7 -     (   VD P2.1)
;          
;10. P0.5 -> P1.4 -     (   VD P2.0)
;         
;11. P0.7 -> P1.0,P1.1,P1.4,P1.5,P1.6,P1.7 -   
;   ( )  (10,25,50,78,100,127) 100-.
;12. P0.6 -> P1.0,P1.3,P1.2,P1.1 -   1,2,3,4 
;13. P0.6 -> P1.7,P1.6,P1.4,P1.5 -   1,2,3,4 
;14. P0.6 -> P3.7 -     1,2,3,4 
;*********************************************************************
;
        DefSeg  All,Absolute
        Seg     All

;=========================================================
;                        
;=========================================================
;
;=========================================================
;                
;=========================================================
Steck   equ     7       ; 

KB	equ	30h	;   
			;  50  ( 0:
			;0 - , 1 - )
Shift	equ	70h	;  /2  (-12/-24),
			; (+12/24),  (0)
Channel	equ	71h	; 
Speed	equ	72h	;  ()
Sw1	equ	73h	; 1
Sw2	equ	74h	; 2
Sw3	equ	75h	; 3
Sw4	equ	76h	; 4

;R0 -   
;R1 -   .
;R2
;R3
;R4 -     11101111b..11111110b
;R5 -     (  )
;R6 -       (1-10)
;R7 -       (1-5)

;-------  ------------
KBup 	equ	27h.0	;   
KBdn 	equ	27h.1	;    
;=========================================================
;              / 
;=========================================================
;P0 -     
;P0.0 ... P0.4 - 5   0...4
;P0.5 ... P0.7 - 3  ()  5...7

;P1 -      
;P1.0 ... P1.7 - 8   B0...B7

pVD2	equ	P2.0	; [SLOW]
pVD5	equ	P2.1	; [DEMO2]
;P2 -   

;               P3.0    ;RxD - in   ( )
;               P3.1    ;TxD - out MIDI   

TestSig equ     P3.3    ;out  ;  (VD3) [PLAY]
TonSig	equ	P3.4	;out  ;   MIDI 
			      ;(VD4) [NULL-PLAY]

LnB8	equ	P3.6	;in -    B8
LnB9	equ	P3.7	;in -    B9

;=========================================================
;                      
;=========================================================

        ORG     0
        LJMP    Begin
;
        db      ' mdt17 '
;
        ORG     0BH             ;Timer counter TF0 Interrapt
        reti
;
        ORG     13H             ;pp  INT1 (TxD)
        reti
;
        ORG     23H             ;  . 
        reti
;
;******************************************************
;                  
;******************************************************
Begin:  mov     SP,#Steck       ; 

;-------------   -------------
        mov     SCON,#01110000b ;    1
;-------------  ------------
        mov     TMOD,#00100010b ;  
        ;T/C1:      TR1
        ;      8   /
        ;T/C0:      TR0
        ;      8   /
        mov     TH1,#254        ;  31250 
        mov     TL1,#254
	mov	PCON,#10000000b	;SMOD=1
        MOV     IE,#00010110b   ;   T/C0,INT1
                                ;  p
        SETB    PT0             ; T/C0
        setb    IT1             ; INT1 p  p

        SETB    TR1             ; T/C1
	clr	F0		;     
				; 
	mov	Shift,#0	;
	mov	Channel,#1	; 1
	mov	Speed,#100	;  ()
;    
	mov	DPTR,#AdrKl-KB	;    

;   (  )
	mov	R0,#KB		;c   
	mov	R1,#50		;50  ( )
clram:	mov	@R0,#1		;  
	inc	R0
	djnz	R1,clram
;=========================================================	
	lcall	ChnLight	;   HEX

;------------------    -------------------

cyrcle:	
	mov	R7,#8		;  
	mov	R4,#01111111b	;  .

cyr1:
	mov	P0,R4		;  0
;     0   
	mov	R0,#250
cyr10:	djnz	R0,cyr10	; 0,5 

	mov	R6,#8		;  (1-8)
				;  1  8 
	mov	R5,P1		;   
	
;   .   ( R7 = 6...8) 
	cjne	R7,#8,cr200
;   .5 (P0.7) mcs51.32
	jb	LnB9,cr101	
; P0.7 -> P3.7 -    HEX  
	lcall	ChnLight	;   HEX
	ljmp	mp23		;   
cr101:	jb	LnB8,cr102	
; P0.7 -> P3.6 -    (.3)
	lcall	ChnLight	;   HEX
	clr	F0		;  
; P0.7 -> P1.0,P1.1,P1.4,P1.5,P1.6,P1.7 -   
;   ( )  (10,25,50,78,100,127) 100-.
cr102:	mov	A,R5
	rrc	A
	jc	cr103
	mov	Speed,#25	;	
	mov	A,#1000b
	jmp	mp123
cr103:	rrc	A
	jc	cr104	
	mov	Speed,#45	;	
	mov	A,#1100b
	jmp	mp123
cr104:	rrc	A
	rrc	A
	rrc	A
	jc	cr105	
	mov	Speed,#60	;  	
	mov	A,#1010b
	jmp	mp123
cr105:	rrc	A
	jc	cr106	
	mov	Speed,#80	;	
	mov	A,#1110b
	jmp	mp123
cr106:	rrc	A
	jc	cr107	
	mov	Speed,#100	;	
	mov	A,#1101b
	jmp	mp123
cr107:	rrc	A
	jc	cr108	
	mov	Speed,#127	;	
	mov	A,#1111b

mp123:	lcall	AccLight
	setb	F0		; 
cr108:	ljmp	mp23		;   

cr200:	cjne	R7,#7,cr300
;   .4 (P0.6) mcs51.33
	jb	LnB9,cr201	
; P0.6 -> P3.7 -     1,2,3,4
	lcall	SwLight
	setb	F0		; 
	ljmp	mp23		;   
cr201:	cjne	R5,#0FFh,cr202	;
	ljmp	mp23		;   
; P0.6 -> P1.0,P1.3,P1.2,P1.1 -   1,2,3,4 
; P0.6 -> P1.7,P1.6,P1.4,P1.5 -   1,2,3,4 
cr202:	lcall	SwControl	; 
	lcall	SwLight		; 
	setb	F0		; 
	ljmp	mp23		;   

cr300:	cjne	R7,#6,cyr2
;   .3 (P0.5) mcs51.34
	jb	LnB8,cr305	
; P0.5 -> P3.6 -    ( VD P3.4)
	mov	A,#0010b
	lcall	AccLight
	mov	Shift,#12	;  
	setb	F0		; 
	ljmp	mp23		;   
cr305:	jb	LnB9,cr302	
; P0.5 -> P3.7 -     ( VD P2.1)
	mov	A,#0001b
	lcall	AccLight
	mov	Shift,#24	;   
	setb	F0		; 
	ljmp	mp23		;   
cr302:	mov	A,R5
	rrc	A
	rrc	A
	jc	cr303	
; P0.5 -> P1.1 -    ( VD P3.3)
	mov	A,#0100b
	lcall	AccLight
	mov	Shift,#(-12)	;  
	setb	F0		; 
	ljmp	mp23		;   
cr303:	rrc	A
	jc	cr306	
; P0.5 -> P1.2 -   ( )
	mov	A,#0000b
	lcall	AccLight
	mov	Shift,#0	; 
	setb	F0		; 
	ljmp	mp23		;   
cr306:	rrc	A
	rrc	A
	jc	cr304	
; P0.5 -> P1.4 -     (   VD P2.0)
	mov	A,#1000b
	lcall	AccLight
	mov	Shift,#(-24)	;   
	setb	F0		; 
cr304:	ljmp	mp23		;   

cyr2:
;       (R7/R6)
; : Adr = (R6-1)*5+R7-1
	lcall	AdrKey

	mov	A,R5		;   
	rlc	A		;   (=7)
	mov	R5,A

	jnc	mp1		; 
; -   
;---------------------------------------
;      
;  R7/R6
;    
	mov	A,@R0
	rrc	A
;---------------------------------------
	jc	mp3		;=1 -   
; -    
;---------------------------------------
; 1   
;  R7/R6
;     " "
	mov	@R0,#1
;---------------------------------------
	lcall	DePress		; MIDI 
;    R7/R6
	jmp	mp3

mp1:				; -  
;---------------------------------------
;      
;  R7/R6
;    
	mov	A,@R0
	rrc	A
;---------------------------------------
	jnc	mp3		;=0 -  
; -     
;---------------------------------------
; 0   
;  R7/R6
;     ""
	mov	@R0,#0
;---------------------------------------
	lcall	Press		; MIDI 
;    R7/R6

;----------------------------------------
; ,  R6 <> 0 (    8)
;     R6 -  1 
;----------------------------------------
mp3:	djnz	R6,cyr2


;         3
	mov	R6,#9		;  9

;       (R7/R6)
; : Adr = (R6-1)*5+R7-1
	lcall	AdrKey

	jnb	LnB8,mp12	;  - 
; -   
;---------------------------------------
;      
;  R7/R6
;    
	mov	A,@R0
	rrc	A
;---------------------------------------
	jc	mp13		;=1 -   
; -    
;---------------------------------------
; 1   
;  R7/R6
;     " "
	mov	@R0,#1
;---------------------------------------
	lcall	DePress		; MIDI 
;    R7/R6
	jmp	mp13
mp12:				; -  
;---------------------------------------
;      
;  R7/R6
;    
	mov	A,@R0
	rrc	A
;---------------------------------------
	jnc	mp13		;=0 -  
; -     
;---------------------------------------
; 0   
;  R7/R6
;     ""
	mov	@R0,#0
;---------------------------------------
	lcall	Press		; MIDI 
;    R7/R6

mp13:	
	mov	R6,#10		;  10

;       (R7/R6)
; : Adr = (R6-1)*5+R7-1
	lcall	AdrKey

	jnb	LnB9,mp22	;  - 
; -   
;---------------------------------------
;      
;  R7/R6
;    
	mov	A,@R0
	rrc	A
;---------------------------------------
	jc	mp23		;=1 -   
; -    
;---------------------------------------
; 1   
;  R7/R6
;     " "
	mov	@R0,#1
;---------------------------------------
	lcall	DePress		; MIDI 
;    R7/R6
	jmp	mp23
mp22:				; -  
;---------------------------------------
;      
;  R7/R6
;    
	mov	A,@R0
	rrc	A
;---------------------------------------
	jnc	mp23		;=0 -  
; -     
;---------------------------------------
; 0   
;  R7/R6
;     ""
	mov	@R0,#0
;---------------------------------------
	lcall	Press		; MIDI 
;    R7/R6
mp23:

	mov	A,R4
	rr	A		;   
	mov	R4,A
;----------------------------------------
; ,  R7 <> 0 (  )
;     R7
;----------------------------------------
	djnz	R7,cyr1a	;  5  

;---------------------------------------------------
;    ( )
;---------------------------------------------------
	jb	F0,mp30		;   
	mov	A,R2		; 2 
	add	A,#2
	mov	R2,A
	rlc	A
	jnc	mp31
	lcall	ChnLight	;  
	ljmp	mp30
mp31:   mov	A,Channel       	;  
	cpl	A
	lcall	AccLight
mp30:	
	jmp	Cyrcle
cyr1a:	ljmp	cyr1

;=========================================================	

OutByte:
	mov	A,R1
	mov     SBUF,A          ;  
;   
	mov	R1,#250
po2:	djnz	R1,po2
	ret

;------------------------------------------------
;   (R0 =   + 48)
Press:
	jnb	F0,pr01		; = 0 -  

	mov	A,#1111b        ;  
	lcall	AccLight
	mov	A,Channel	;()
	orl	A,#90h
	mov	R1,A		;  
	lcall	OutByte		;
	mov	A,R0
	movc	A,@A+DPTR	;  
	add	A,Shift		;
	mov	R1,A		; 
	lcall	OutByte		;
	mov	R1,Speed	; 
	lcall	OutByte		;
	ret

; F0=0 -    
pr01:	cjne	R0,#KB,pr02	;  (0)
	mov	Channel,#1	; 1
	ljmp	pr90
pr02:	cjne	R0,#KB+10,pr03	; (2) ,
	mov	Channel,#2	; 2
	ljmp	pr90
pr03:	cjne	R0,#KB+20,pr04	; (4) ,
	mov	Channel,#3	; 3
	ljmp	pr90
pr04:	cjne	R0,#KB+30,pr05	; (6) ,
	mov	Channel,#4	; 4
	ljmp	pr90
pr05:	cjne	R0,#KB+35,pr06	; (7) ,
	mov	Channel,#5	; 5
	ljmp	pr90
pr06:	cjne	R0,#KB+45,pr07	; (9) ,
	mov	Channel,#6	; 6
	ljmp	pr90
pr07:	cjne	R0,#KB+6,pr08	; (11) ,
	mov	Channel,#7	; 7
	ljmp	pr90
pr08:	cjne	R0,#KB+11,pr09	; (12) ,
	mov	Channel,#8	; 8
	ljmp	pr90
pr09:	cjne	R0,#KB+21,pr10	; (14) ,
	mov	Channel,#9	; 9
	ljmp	pr90
pr10:	cjne	R0,#KB+31,pr11	; (16) ,
	mov	Channel,#10	; 10
	ljmp	pr90
pr11:	cjne	R0,#KB+41,pr12	; (18) ,
	mov	Channel,#11	; 11
	ljmp	pr90
pr12:	cjne	R0,#KB+46,pr13	; (19) ,
	mov	Channel,#12	; 12
	ljmp	pr90
pr13:	cjne	R0,#KB+7,pr14	; (21) ,
	mov	Channel,#13	; 13
	ljmp	pr90
pr14:	cjne	R0,#KB+17,pr15	; (23) ,
	mov	Channel,#14	; 14
	ljmp	pr90
pr15:	cjne	R0,#KB+22,pr16	; (24) ,
	mov	Channel,#15	; 15
	ljmp	pr90
pr16:	cjne	R0,#KB+32,pr90	; (26) ,
	mov	Channel,#0	; 16 (0)
;    4 
ChnLight:
pr90:	mov	A,Channel
AccLight:			;   
	rrc	A
	mov	pVD5,C		;D0 HEX 
	rrc	A
	mov	TonSig,C	;D1 HEX 
	rrc	A
	mov	TestSig,C	;D2 HEX 
	rrc	A
	mov	pVD2,C		;D3 HEX 
	ret

;------------------------------------------------
;   (R0 =   + 48)
DePress:
	jnb	F0,dp01		; = 0 - 
        lcall	ShftLight       ;  

	mov	A,Channel	;()
	orl	A,#80h
	mov	R1,A		;  
	lcall	OutByte		;
	mov	A,R0
	movc	A,@A+DPTR	;  
	add	A,Shift		;
	mov	R1,A		; 
	lcall	OutByte		;
	mov	R1,Speed	; 
	lcall	OutByte		;
dp01:	setb	F0

	ret

;------------------------------------------------
;      (Shift)
ShftLight:
	mov	A,Shift
	jz	sl01		;
	cjne	A,#12,sl02
	mov	A,#0010b	;  
	ajmp	sl01
sl02:	cjne	A,#24,sl03
	mov	A,#0001b	;   
	ajmp	sl01
sl03:	cjne	A,#(-12),sl04
	mov	A,#0100b	;  
	ajmp	sl01
sl04:	cjne	A,#(-24),sl05
	mov	A,#1000b	;   
	ajmp	sl01
sl05:	mov	A,#1001b	;
sl01:	lcall	AccLight
sc101:	ret

;------------------------------------------------
;  Sw1 - Sw4
; P0.6 -> P1.0,P1.3,P1.2,P1.1 -   1,2,3,4 
; P0.6 -> P1.7,P1.6,P1.4,P1.5 -   1,2,3,4 
SwControl:			; 
	mov	A,R5		; 
;  
	rrc	A
	jc	sc01		; 1   - 
	mov	A,Sw1		; ()
	jnz	sc101		; 1  
	mov	Sw1,#1		;
	mov	A,#11h		;1 
	ajmp	MidiSw		; MIDI 
sc01:	rrc	A
	jc	sc02		; 4   - 
	mov	A,Sw4		; ()
	jnz	sc10		; 4  
	mov	Sw4,#1		;
	mov	A,#41h		;4 
	ajmp	MidiSw		; MIDI 
sc02:	rrc	A
	jc	sc03		; 3   - 
	mov	A,Sw3		; ()
	jnz	sc10		; 3  
	mov	Sw3,#1		;
	mov	A,#31h		;3 
	ajmp	MidiSw		; MIDI 
sc03:	rrc	A
	jc	sc04		; 2   - 
	mov	A,Sw2		; ()
	jnz	sc10		; 2  
	mov	Sw2,#1		;
	mov	A,#21h		;2 
	ajmp	MidiSw		; MIDI 
;  
sc04:	rrc	A
	jc	sc05		; 3   - 
	mov	A,Sw3		; ()
	jz	sc10		; 3  
	mov	Sw3,#0		;
	mov	A,#30h		;3 
	ajmp	MidiSw		; MIDI 
sc05:	rrc	A
	jc	sc06		; 4   - 
	mov	A,Sw4		; ()
	jz	sc10		; 4  
	mov	Sw4,#0		;
	mov	A,#40h		;4 
	ajmp	MidiSw		; MIDI 
sc06:	rrc	A
	jc	sc07		; 2   - 
	mov	A,Sw2		; ()
	jz	sc10		; 2  
	mov	Sw2,#0		;
	mov	A,#20h		;2 
	ajmp	MidiSw		; MIDI 
sc07:	rrc	A
	jc	sc10		; 1   - 
	mov	A,Sw1		; ()
	jz	sc10		; 1  
	mov	Sw1,#0		;
	mov	A,#10h		;1 

MidiSw:	mov	R0,A		; MIDI 
	mov	A,Channel	;()
	orl	A,#0B0h		; 
	mov	R1,A 
	lcall	OutByte		;
	mov	A,R0
	swap	A		; 
	anl	A,#0Fh		; 
	dec	A		; 40h  43h
	orl	A,#40h		;
	mov	R1,A
	lcall	OutByte		;
	mov	A,R0
	anl	A,#0Fh		;0 - , 1 - 
	jz	sc08
	mov	A,#7Fh		;
sc08:	mov	R1,A
	lcall	OutByte		;
sc10:
	ret

;------------------------------------------------
;  Sw1 - Sw4
SwLight:			; 
	mov	A,Sw1		; 1
	rrc	A
	mov	pVD2,C		;V2
	mov	A,Sw2		; 2
	rrc	A
	mov	TestSig,C	;V3
	mov	A,Sw3		; 3
	rrc	A
	mov	TonSig,C	;V4
	mov	A,Sw4		; 4
	rrc	A
	mov	pVD5,C		;V5
	ret

;------------------------------------------------
;       (R7/R6)
; : R0 = #KB+(R6-1)*5+R7-1
AdrKey:
	mov	A,R6
	dec	A
	mov	B,#5
	mul	AB
	add	A,R7
	dec	A
	add	A,#KB		;   
	mov	R0,A
	ret
;-----------------------------------------------------
;   
AdrKl:	db	29h,33h,3dh,47h,51h
	db	2ah,34h,3eh,48h,52h
	db	2bh,35h,3fh,49h,53h
	db	2ch,36h,40h,4ah,54h
	db	2dh,37h,41h,4bh,55h
	db	2eh,38h,42h,4ch,56h
	db	2fh,39h,43h,4dh,57h
	db	30h,3ah,44h,4eh,58h
	db	31h,3bh,45h,4fh,59h
	db	32h,3ch,46h,50h
;
        END
;